// Seznam.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>
#include <string>
using namespace std;

struct prvek{
		int key;
		string value;
		prvek *next;
	};

struct seznam{
		prvek *first;
		prvek *last;
	};

seznam s;

void init(seznam &d){
	d.first = nullptr;
	d.last = nullptr;
}

void pridejPrvekKonec(seznam &d,int k, string v){
	prvek* p = new prvek;
	p->key=k;
	p->value=v;
	p->next=nullptr;

	if (d.last!=nullptr)
		d.last->next=p;
	else 
		d.first =p;
	d.last=p;
}

void pridejPrvekZacatek(seznam &d,int k, string v){
	prvek* p = new prvek;
	p->key=k;
	p->value=v;
	p->next=nullptr;

	if (d.first!=nullptr)
		p->next =d.first;
	else 
		d.last =p;

	d.first = p;
}

void vypis(seznam &d){
	prvek* p;
	p=d.first;
	while(p!=nullptr){
		cout << p->value << " " << p->key << endl;
		p=p->next;
	}}

void hledej(seznam &d, int k){
	prvek* p;
	p=d.first;
	while(p!=nullptr){
		if(p->key == k)
			cout << p->value << " " << p->key << endl;
		p=p->next;
	}
}

prvek* find(seznam &d, int k){
	prvek* p;
	p=d.first;
	while(p!=nullptr){
		if(p->key == k)
			return p;
		p=p->next;
	}
	return NULL;
}

prvek* find2 (seznam &d, int k){
	prvek* p;
	p=d.first;
	bool stop = false;
	while(p!=nullptr && ! stop){
		if(p->key == k)
			stop = true;
		else 
		   p=p->next;
	}
	return p;
}
prvek* find3 (seznam &d, int k){
	prvek * answer = nullptr;
	prvek* p = d.first;
	while(p!=nullptr && answer == nullptr){
		if(p->key == k)
			answer = p;
        p=p->next;
	}
	return answer;
}

prvek* find4 (seznam &d, int k){
	prvek* p = d.first;
	while(p!=nullptr && p->key != k)
        p=p->next;
	return p;
}

prvek* find5 (seznam &d, int k){
	prvek* p = d.first;
	while( p->key != k && p != nullptr) // SPATNE
        p=p->next;
	return p;
}

int _tmain (int argc, _TCHAR* argv[])
{
	init(s);
	pridejPrvekKonec(s,2,"m");
	pridejPrvekKonec(s,5,"k");
	pridejPrvekZacatek(s,1,"a");
	vypis(s);
	cout << "Hotovo" << endl;
	system ("pause");

	return 0;
}

